#ifndef CONTAINERVWIDGET_H
#define CONTAINERVWIDGET_H

#include "Widget.h"
#include "CursorTask.h"
#include <vector>


class ContainerVWidget : public Widget
{
    public:
        ContainerVWidget() { widgettype = "ContainerV"; };
        ContainerVWidget( char *l, int x, int y, int w, int h, Widget *p ) : Widget( l, x, y, w, h, p ) { widgettype = "ContainerV"; };
        virtual ~ContainerVWidget() { };

        virtual void adjust();
        virtual void addtocontainer( Widget* content );

        virtual void setsize( int sizeH ) { sizevgrid = sizeH; }
        virtual int getsize() { return sizevgrid; };

        virtual void logic( CursorTask *mouse ) override;
        virtual void render( SDL_Surface *screen, nSDL_Font *currentfont ) override;

    protected:
        int sizevgrid;
        std::vector<Widget*> gridvwidget;


    private:
};

#endif// CONTAINERVWIDGET_H
