#ifndef WIDGETAPPLICATION_H
#define WIDGETAPPLICATION_H

#include <SDL/SDL.h>
#include <SDL/SDL_video.h>
#include "CursorTask.h"
#include "Widget.h"

#include <vector>



class WidgetApplication
{
    public:
        WidgetApplication();
        virtual ~WidgetApplication();
        virtual void addchild( Widget *root );
        virtual void render( void );
        virtual void logic( void );

        virtual void setuniformbackgroundcolor( Uint8 r, Uint8 g, Uint8 b);
        virtual void setbackgroundpicture( char *filename );

    protected:

        bool uniform_background = false;
        bool background_wallpaper = false;

        Uint8 r_background = 0;
        Uint8 g_background = 0;
        Uint8 b_background = 0;
        Uint32 rgb_background = 0;
        SDL_Surface *background_image=nullptr;
        SDL_Rect position_background;

        CursorTask *mouse = nullptr;
        SDL_Surface *screen = nullptr;
        nSDL_Font *currentfont = nullptr;

        std::vector< Widget* > rootwidgets;

    private:
};

#endif // WIDGETAPPLICATION_H
